3 # Copyright (c) 2006 - 2008 Kungliga Tekniska Högskolan
4 # (Royal Institute of Technology, Stockholm, Sweden).
7 # Redistribution and use in source and binary forms, with or without
8 # modification, are permitted provided that the following conditions
11 # 1. Redistributions of source code must retain the above copyright
12 # notice, this list of conditions and the following disclaimer.
14 # 2. Redistributions in binary form must reproduce the above copyright
15 # notice, this list of conditions and the following disclaimer in the
16 # documentation and/or other materials provided with the distribution.
18 # 3. Neither the name of the Institute nor the names of its contributors
19 # may be used to endorse or promote products derived from this software
20 # without specific prior written permission.
22 # THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
23 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
24 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
25 # ARE DISCLAIMED. IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
26 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
27 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
28 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
29 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
30 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
31 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
34 top_builddir
="@top_builddir@"
35 env_setup
="@env_setup@"
38 testfailed
="echo test failed; cat messages.log; exit 1"
42 # If there is no useful db support compile in, disable test
50 kadmin
="${kadmin} -l -r $R"
51 kdc
="${kdc} --addresses=localhost -P $port"
53 afsserver
=afs
/test.h5l.se
54 hostserver
=host
/server.
test.h5l.se
55 cache
="FILE:${objdir}/cache.krb5"
57 kinit
="${kinit} -c $cache ${afs_no_afslog}"
58 klist
="${klist} -c $cache"
59 kgetcred
="${kgetcred} -c $cache"
60 kdestroy
="${kdestroy} -c $cache ${afs_no_unlog}"
62 KRB5_CONFIG
="${objdir}/krb5.conf"
72 echo Creating database
75 --realm-max-ticket-life=1day \
76 --realm-max-renewable-life=1month \
81 --realm-max-ticket-life=1day \
82 --realm-max-renewable-life=1month \
85 ${kadmin} cpw -r krbtgt/${R}@${R} ||
exit 1
87 ${kadmin} add
-p foo
--use-defaults foo@
${R} ||
exit 1
88 ${kadmin} add -p kaka --use-defaults ${afsserver}@${R} ||
exit 1
89 ${kadmin} add -p kaka --use-defaults ${hostserver}@${R} ||
exit 1
90 ${kadmin} add_enctype -r ${afsserver}@${R} des-cbc-crc ||
exit 1
91 ${kadmin} add_enctype -r ${hostserver}@${R} des-cbc-crc ||
exit 1
93 echo "Doing database check"
94 ${kadmin} check
${R} ||
exit 1
96 echo foo
> ${objdir}/foopassword
103 if [ "$?" != 0 ] ; then
108 trap "kill -9 ${kdcpid}; echo signal killing kdc; exit 1;" EXIT
112 echo "Getting client initial tickets"; > messages.log
113 ${kinit} --password-file=${objdir}/foopassword foo@
$R || \
114 { ec
=1 ; eval "${testfailed}"; }
115 echo "Getting non des tickets (afs)"; > messages.log
116 ${kgetcred} ${afsserver}@${R} || { ec=1 ; eval "${testfailed}"; }
117 ${klist} -v | grep des-cbc-crc > /dev/null && { ec=1 ; eval "${testfailed}"; }
118 echo "Getting non des tickets (host/)"; > messages.log
119 ${kgetcred} ${hostserver}@${R} || { ec=1 ; eval "${testfailed}"; }
120 ${klist} -v | grep des-cbc-crc > /dev/null && { ec=1 ; eval "${testfailed}"; }
124 echo "Getting client initial tickets"; > messages.log
125 ${kinit} --password-file=${objdir}/foopassword foo@
$R || \
126 { ec
=1 ; eval "${testfailed}"; }
127 echo "Getting des tickets (fail test)"; > messages.log
128 ${kgetcred} -e des-cbc-crc ${hostserver}@${R} 2>/dev
/null
&& \
129 { ec
=1 ; eval "${testfailed}"; }
130 echo "Getting non des tickets"; > messages.log
131 ${kgetcred} ${afsserver}@${R} || { ec=1 ; eval "${testfailed}"; }
132 ${klist} -v | grep des-cbc-crc > /dev/null && { ec=1 ; eval "${testfailed}"; }
135 KRB5_CONFIG
="${objdir}/krb5-weak.conf"
137 echo "Getting client initial tickets"; > messages.log
138 ${kinit} --password-file=${objdir}/foopassword foo@
$R || \
139 { ec
=1 ; eval "${testfailed}"; }
141 echo "Getting non des tickets (host/), failure test"; > messages.log
142 ${kgetcred} -e des-cbc-crc ${hostserver}@${R} 2>/dev
/null
&& \
143 { ec
=1 ; eval "${testfailed}"; }
144 ${klist} -v | grep des-cbc-crc > /dev/null && { ec=1 ; eval "${testfailed}"; }
146 echo "Getting des tickets (afs)"; > messages.log
147 ${kgetcred} -e des-cbc-crc ${afsserver}@${R} || { ec=1 ; eval "${testfailed}"; }
148 ${klist} -v | grep des-cbc-crc > /dev/null || { ec=1 ; eval "${testfailed}"; }
156 echo "killing kdc (${kdcpid})"
157 sh
${leaks_kill} kdc
$kdcpid ||
exit 1